<template>
  <div class="login__content-wrapper">
    <page-title>Crie sua conta</page-title>
    <separator>
      Faça o cadastro com as redes sociais
    </separator>
    <social />
    <separator>Ou utilize os campos abaixo</separator>
    <a-form :form="form" class="login__form" @submit.prevent="signUp">
      <div class="login__form-section">
        <div class="login__form-section-row">
          <a-form-item label="Nome">
            <a-input
              id="name"
              v-decorator="[
                'name',
                { rules: [{ required: true, message: 'Por favor seu nome' }] }
              ]"
              type="text"
              class="login__form-input"
              auto-focus
            />
          </a-form-item>
        </div>

        <div class="login__form-section-row">
          <a-form-item label="Sobrenome">
            <a-input
              id="surname"
              v-decorator="[
                'surname',
                {
                  rules: [
                    { required: true, message: 'Por favor seu sobrenome' }
                  ]
                }
              ]"
              type="text"
              class="login__form-input"
            />
          </a-form-item>
        </div>
      </div>

      <div class="login__form-section">
        <div class="login__form-section-row">
          <a-form-item label="E-mail">
            <a-input
              id="email"
              v-decorator="[
                'email',
                {
                  rules: [
                    { required: true, message: 'Por favor seu email' },
                    {
                      type: 'email',
                      message: 'Por favor digite um email válido'
                    }
                  ]
                }
              ]"
              class="login__form-input"
            />
          </a-form-item>
        </div>

        <div class="login__form-section-row">
          <a-form-item label="Senha">
            <a-input
              id="password"
              ref="passwordInput"
              v-decorator="[
                'password',
                {
                  rules: [{ required: true, message: 'Por favor sua senha' }]
                }
              ]"
              :type="showPassword ? 'text' : 'password'"
              class="login__form-input"
            >
              <div
                slot="suffix"
                style="cursor: pointer;"
                @click="togglePassword()"
              >
                <a-icon v-if="showPassword" type="eye" />
                <a-icon v-else type="eye-invisible" />
              </div>
            </a-input>
          </a-form-item>
        </div>
      </div>

      <separator terms>
        Ao fazer o cadastro, você concorda com os
        <nuxt-link to="/">Termos de licença de uso</nuxt-link>.
      </separator>

      <submit-button>
        Fazer cadastro
      </submit-button>
    </a-form>
  </div>
</template>

<script>
import { mapActions } from 'vuex'
import { db, auth } from '~/firebase'

import Title from '~/components/Auth/Title.vue'
import Separator from '~/components/Auth/Separator.vue'
import Social from '~/components/Auth/Social.vue'
import Button from '~/components/Auth/Button.vue'

export default {
  components: {
    'page-title': Title,
    'submit-button': Button,
    Separator,
    Social
  },
  middleware: 'auth',
  data() {
    return {
      showPassword: false,
      form: this.$form.createForm(this)
    }
  },
  head() {
    return {
      title: 'Acolher.me - Cadastro'
    }
  },
  layout: 'auth',
  transition: {
    enterActiveClass: 'animated slideInLeft',
    leaveActiveClass: 'animated fadeOutLeft'
  },
  methods: {
    ...mapActions('user', ['login']),
    signUp() {
      this.form.validateFieldsAndScroll(async (err, values) => {
        if (!err) {
          try {
            const userRef = db.collection('user')

            await auth.createUserWithEmailAndPassword(
              values.email,
              values.password
            )

            const user = await auth.currentUser
            await user.updateProfile({
              displayName: `${values.name} ${values.surname}`
            })

            const { uid, email, photoURL, displayName, emailVerified } = user
            const token = await user.getIdToken(true)
            const { exists } = await userRef.doc(uid).get()

            const userData = {
              uid,
              email,
              photoURL,
              displayName,
              token,
              isVerified: false
            }

            if (exists) {
              await this.login({
                uid,
                email,
                photoURL,
                displayName,
                token,
                isVerified: emailVerified
              })

              if (emailVerified) {
                this.$router.push({ path: '/admin' })
              } else {
                this.$router.push({ path: '/auth/email-verification' })
              }
            } else {
              await userRef
                .doc(uid)
                .set({ uid, email, photoURL, displayName, isVerified: false })

              const actionCodeSettings = {
                url: 'https://localhost:3000?email=' + user.email
              }
              await user.sendEmailVerification(actionCodeSettings)

              await this.login(userData)

              this.$router.push({ path: '/auth/email-verification' })
            }
          } catch (error) {
            console.log(error)
          }
        }
      })
    },
    togglePassword() {
      this.showPassword = !this.showPassword
      this.$refs.passwordInput.focus()
    }
  }
}
</script>

<style lang="less" scoped>
.ant-form-item-required:before {
  content: '';
}

.login {
  &__form {
    display: flex;
    flex-direction: column;
    align-items: center;
    width: 100%;

    @media screen and (min-width: 768px) {
      max-width: 500px;
    }

    &-section {
      display: flex;
      flex-direction: column;
      justify-content: space-between;
      width: 100%;

      @media screen and (min-width: 768px) {
        flex-direction: row;
      }

      &-row {
        position: relative;
        width: 100%;

        @media screen and (min-width: 768px) {
          width: 48%;
        }
      }
    }

    &-input {
      width: 100%;
    }

    &-button {
      margin-top: 20px;
      width: 60%;
    }
  }

  &__content {
    &-wrapper {
      width: 100%;
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
    }
  }
}
</style>
